unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, ShellCtrls, StdCtrls,
  SDL_Thumbnails, SDL_FolderTree;

type
  TFrmJpgBrowser = class(TForm)
    Panel1: TPanel;
    Thumbs1: TThumbnails;
    Panel2: TPanel;
    LargeImg: TImage;
    Splitter1: TSplitter;
    SBarThumbs: TScrollBar;
    FolderTree1: TFolderTree;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Thumbs1ImageRequest(Sender: TObject; ThumbID: Integer;
      var HowToProcess: TImageRequestProcessing; var MarkIt: Integer;
      var ImgBuffer: TBitmap);
    procedure Thumbs1ImageClick(Sender: TObject; X, Y, ThumbID: Integer);
    procedure SBarThumbsChange(Sender: TObject);
    procedure Thumbs1FirstImageRequest(Sender: TObject);
    procedure Thumbs1LastImageRequest(Sender: TObject);
    procedure FolderTree1Click(Sender: TObject);
  private
    Img     : TImage;
    SL      : TStringList;
  public
    { Public declarations }
  end;

var
  FrmJpgBrowser: TFrmJpgBrowser;

implementation

{$R *.dfm}

uses
  jpeg, SDL_filesys;

(******************************************************************************)
procedure TFrmJpgBrowser.FormCreate(Sender: TObject);
(******************************************************************************)

begin
Img := TImage.Create(self);
SL := TStringList.Create;
end;

(******************************************************************************)
procedure TFrmJpgBrowser.FolderTree1Click(Sender: TObject);
(******************************************************************************)

begin
SL.Clear;
ScanFilesToStrList (FolderTree1.Directory+'\*.jpg', false, SL, nil);
if SL.Count > 0
  then begin
       Thumbs1.Max := SL.Count;
       SBarThumbs.Max := SL.Count;
       Thumbs1.Visible := true;
       end
  else Thumbs1.Visible := false;

end;

(******************************************************************************)
procedure TFrmJpgBrowser.FormClose(Sender: TObject; var Action: TCloseAction);
(******************************************************************************)

begin
Img.Free;
SL.Free;
end;

(******************************************************************************)
procedure TFrmJpgBrowser.FormShow(Sender: TObject);
(******************************************************************************)

var
  path : string;

begin
path := ExtractFilePath(ParamStr(0));
FolderTree1.SelectPath(path);
SL.Clear;
ScanFilesToStrList (path+'*.jpg', false, SL, nil);
Thumbs1.Max := SL.Count;
end;

(******************************************************************************)
procedure TFrmJpgBrowser.Thumbs1ImageRequest(Sender: TObject; ThumbID: Integer;
  var HowToProcess: TImageRequestProcessing; var MarkIt: Integer;
  var ImgBuffer: TBitmap);
(******************************************************************************)

var
  FName : string;

begin
if (ThumbID >= 1) and (ThumbID <= SL.Count) then
  begin
  FName := SL.Strings[ThumbID-1];
  Img.Picture.LoadFromFile(FName);
  ImgBuffer.Assign(Img.Picture.Graphic);
  HowToProcess := irpShowSlide;
  end;
end;

(******************************************************************************)
procedure TFrmJpgBrowser.Thumbs1ImageClick(Sender: TObject; X, Y,
  ThumbID: Integer);
(******************************************************************************)

var
  FName : string;

begin
if (ThumbID >= 1) and (ThumbID <= SL.Count) then
  begin
  FName := SL.Strings[ThumbID-1];
  LargeImg.Picture.LoadFromFile(FName);
  end;
end;


(******************************************************************************)
procedure TFrmJpgBrowser.SBarThumbsChange(Sender: TObject);
(******************************************************************************)

begin
Thumbs1.FirstThumbIdx := SBarThumbs.Position;
end;

(******************************************************************************)
procedure TFrmJpgBrowser.Thumbs1FirstImageRequest(Sender: TObject);
(******************************************************************************)

begin
Screen.Cursor := crHourGlass;
end;

(******************************************************************************)
procedure TFrmJpgBrowser.Thumbs1LastImageRequest(Sender: TObject);
(******************************************************************************)

begin
Screen.Cursor := crDefault;
end;

end.
